SystemOrganization addCategory: #ConfigurationOfBP2010H1CI!

Object subclass: #ConfigurationOfBP2010H1CI
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfBP2010H1CI'!

!ConfigurationOfBP2010H1CI class methodsFor: 'as yet unclassified' stamp: 'minor changes 4/19/2011 11:51'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfBP2010H1CI class methodsFor: 'as yet unclassified' stamp: 'minor changes 4/19/2011 11:51'!
ensureMetacello
	"Bootstrap Gofer (if necessary), load latest mcz file for ConfigurationOfMetacello (using old 
	 Gofer API), then load the latest version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [ | error |
		"list of repositories to try, in case primary repository is not accessible"
		(Array 
			with: 'http://www.squeaksource.com/MetacelloRepository' 
			with: 'http://seaside.gemstone.com/ss/metacello') do: [:repositoryUrl |
				([
					Smalltalk at: #Gofer ifAbsent: [
					"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
						self bootstrapPackage: 'Gofer-Core-lr.115' from: repositoryUrl ].
					Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
						gofer := goferClass new
							url: repositoryUrl;
							yourself.
						[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
						gofer load ]]
							on: Error
							do: [ :ex |
								error := ex.
								Transcript 
									cr; 
									show: 'failed ensureMetacello: ';
									show: ex description printString;
									show: '...retrying'.
								"try again"
								ex return: nil ]) ~~ nil
					ifTrue: [
						"load 'default' group of Metacello"
						(Smalltalk at: #ConfigurationOfMetacello) perform: #load.
						^self ]].
		"shouldn't get here unless the load failed ... throw an error"
		self error: 'retry with alternate repository failed: ', error description printString ]! !

!ConfigurationOfBP2010H1CI class methodsFor: 'as yet unclassified' stamp: 'minor changes 4/19/2011 11:52'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfBP2010H1CI class methodsFor: 'as yet unclassified' stamp: 'minor changes 4/19/2011 11:52'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfBP2010H1CI class methodsFor: 'as yet unclassified' stamp: 'minor changes 4/19/2011 11:52'!
load
	"self load"

	^self project latestVersion load! !

!ConfigurationOfBP2010H1CI class methodsFor: 'as yet unclassified' stamp: 'minor changes 4/19/2011 11:52'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfBP2010H1CI class methodsFor: 'as yet unclassified' stamp: 'minor changes 4/19/2011 11:52'!
project

	^self new project! !

!ConfigurationOfBP2010H1CI class methodsFor: 'as yet unclassified' stamp: 'minor changes 4/19/2011 11:52'!
unloadMetacello

	Smalltalk at: #ConfigurationOfMetacello ifPresent: [:cls | cls unloadMetacello ]! !

!ConfigurationOfBP2010H1CI methodsFor: 'as yet unclassified' stamp: 'OrcaSetup 5/11/2011 15:24'!
baseline100: spec
	<version: '1.0-baseline'>

	spec for: #common do: [
		spec 
			blessing: #baseline;
			repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/bp2010h1';
			postLoadDoIt: #setIsOnCIServer.
			
		spec project: 'Orca' with: [
			spec
				className: 'ConfigurationOfOrca';
				repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/bp2010h1'.
		].
	
		spec project: 'OSProcess' with: [
			spec
				className: 'ConfigurationOfOSProcess';
				repository: 'http://www.squeaksource.com/MetacelloRepository'.
		].
	
		spec package: 'CommandShell' with: 
			[spec repository: 'http://www.squeaksource.com/CommandShell' ].
		
		spec package: 'BP2010H1-CI-Srv' 
			with: [ spec requires: #('Orca' 'OSProcess') ]].! !

!ConfigurationOfBP2010H1CI methodsFor: 'as yet unclassified' stamp: 'minor changes 4/19/2011 11:46'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfBP2010H1CI methodsFor: 'as yet unclassified' stamp: 'OrcaSetup 5/11/2011 16:14'!
setIsOnCIServer

	
	OrcaTestCase setIsOnCIServer: true.
	(Smalltalk at: #OrcaTranslationUpdatesPrinter) printUpdatesOf: (Smalltalk at: #OrcaTranslatedClass).! !

!ConfigurationOfBP2010H1CI methodsFor: 'as yet unclassified' stamp: 'minor changes 4/19/2011 11:54'!
version100: spec 
	<version: '1.0' imports: #('1.0-baseline') >

	spec for: #common do: [
		spec blessing: #stable.
	].! !
